	data	2048

* zeiger auf wurzel
wurzel:	equ	0

* platz fuer bitstruktur fuer jedes zeichen
bitmap:	equ	4

	bra.s	start
	dc.l	0
	dc.w	$4afb
	dc.w	ne-ns
ns:	dc.b	"Ralf's Extraktor"
ne:
	even

start:	moveq	#0,d7
	moveq	#0,d0
	trap	#1		;current Job
	tst.w	d1
	bne.s	job
	move.w	$110,a0		;install new procedure
	lea	defs,a1
	jsr	(a0)
	rts
defs:	dc.w	1
	dc.w	basic-*
	dc.b	7,'EXTRAKT'
	dc.w	0,0,0

job:	moveq	#11,d0
	moveq	#-1,d1
	moveq	#127,d2
	trap	#1
* anfang als basiroutine
basic:	moveq	#$18,d0
	move.l	#16384,d1
	moveq	#-1,d2
	trap	#1
	tst.w	d0
	bne	exit1
	move.l	a0,a5
	bsr	dcompr
exit:	moveq	#$19,d0
	move.l	a5,a0
	trap	#1	
exit1:	moveq	#5,d0		;remove this Job
	moveq	#-1,d1
	trap	#1	
	moveq	#0,d0		;for basic
	rts

* expandieren
dcompr:	lea	archive,a4
* schleife um alle zu decomprimieren
* informationen lesen, laenge+kompressionsart
dcoml:	move.b	(a4),d0 		* testen ob noch archive
	lsl.l	#8,d0
	move.b	1(a4),d0
	lsl.l	#8,d0
	move.b	2(a4),d0
	lsl.l	#8,d0
	move.b	3(a4),d0
	cmp.l	#'RBDC',d0
	bne.s	edcoml
	move.b	9(a4),d0
	tst.b	d0
	bne.s	next1
	bsr.s	dbyte
	bra.s	next2
next1:	cmp.b	#1,d0
	bne.s	next2
	bsr	dhuff
next2:	move.b  4(a4),d0
	lsl.l	#8,d0
	move.b	5(a4),d0
	lsl.l	#8,d0
	move.b	6(a4),d0
	lsl.l	#8,d0
	move.b	7(a4),d0
	lea	archive,a4
	lea	0(a4,d0.l),a4
	bra.s	dcoml
edcoml:	rts

* jobs ohne kompression erzeugen
dbyte:  move.l	a4,-(a7)
* job erzeugen
	moveq	#1,d0
	moveq	#0,d1
	bsr	getsp
	sub.l	a1,a1
	trap	#1
	tst.w	d0
	bne	edbyte
* job in codebereich kopieren
	lea	62(a4),a1
	bsr	getsp
dbl:	move.b	(a1)+,(a0)+
	subq.l	#1,d2
	bne.s	dbl
* job aktivieren
        moveq	#10,d0
	moveq	#32,d2
	moveq	#0,d3
	trap	#1
edbyte:	move.l	(a7)+,a4
	rts
	
* nach huffman dekomprimieren
dhuff:	move.l	a4,-(a7)
* job erzeugen
	moveq	#1,d0
	moveq	#0,d1
	bsr	getsp
	sub.l	a1,a1
	trap	#1
	tst.w	d0
	bne	edhuff
	move.l	d1,-(a7)
	lea	62(a4),a3
	bsr	mbaum
	bsr	dhuff1
	move.l	(a7)+,d1
* job aktivieren
        moveq	#10,d0
	moveq	#32,d2
	moveq	#0,d3
	trap	#1
edhuff:	move.l	(a7)+,a4
	rts

* baum zum expandieren erzeugen
* platz fuer zeichen
mbaum:	
* platz fuer baum
	lea	bitmap+10(a5),a1
	lea	bitmap(a5),a2
* baum loeschen
	move.w	#2047,d7
mbl:	clr.l	(a2)+
	dbra	d7,mbl
	lea	bitmap(a5),a2
	move.l	a2,wurzel(a5)
* 256 zeichen
	move.w	#255,d7
* 1. zeichen
	moveq	#0,d6
* byte holen
mbl1:	move.b	(a3)+,d1
* 4 bits pro byte
	moveq	#4,d5
mbl2:	rol.b	#2,d1
	move.b	d1,d2
	and.b	#3,d2
* linker ast
	beq.s	mblinks
* ende fuer zeichen
	cmp.b	#3,d2
	beq	embl1
* rechter ast
	move.l	6(a2),d0
	beq.s	mbl4
	move.l	d0,a2
	bra.s	embl3
* neuer rechter ast
mbl4:	move.l	a1,6(a2)
	lea	10(a1),a1
	move.l	6(a2),a2
	bra.s	embl3
* linker ast
mblinks:move.l	2(a2),d0
	beq.s	mbl5
	move.l	d0,a2
	bra.s	embl3
* neuer linker ast
mbl5:	move.l	a1,2(a2)
	lea	10(a1),a1
	move.l	2(a2),a2
	bra.s	embl3
embl1:	cmp.l	wurzel(a5),a2
	beq.s	embl2
* neues zeichen
	move.w	d6,(a2)
	move.l	wurzel(a5),a2
	subq.w	#1,d5
	beq.s	mbl3
	addq.w	#1,d6
	moveq	#0,d0
	dbra	d7,mbl2
	bra.s	embaum
mbl3:	addq.w	#1,d6
	moveq	#0,d0
	dbra	d7,mbl1
	bra.s	embaum
embl2:	addq.w	#1,d6
	subq.w	#1,d5
	beq.s	mbl6
        dbra	d7,mbl2
	moveq	#0,d0
	bra.s	embaum
embl3:	subq.w	#1,d5
	bne.s	mbl2
	bra	mbl1
mbl6:	dbra	d7,mbl1
	moveq	#0,d0
embaum:	tst.w	d0
	rts

* dekomprimieren nach huffman
* anzahl der zu schreibenden bytes feststellen
dhuff1:	moveq	#0,d0
	move.b	10(a4),d7
	lsl.l	#8,d7
	move.b	11(a4),d7
	lsl.l	#8,d7
	move.b	12(a4),d7
	lsl.l	#8,d7
	move.b	13(a4),d7
	tst.l	d7
	beq	edhuff2
	move.l	wurzel(a5),a2
dhuffl3:move.b	(a3)+,d1
* 8 bits
	move.b	d1,d5
	moveq	#0,d0
	moveq	#8,d6
dhuffl4:lsl.b	#1,d5
	bcc.s	dhuffl5
	move.l	6(a2),a2
	tst.l	2(a2)
	bne.s	edhufl4
	tst.l	6(a2)
	bne.s	edhufl4
	move.w	(a2),d1
	move.b	d1,(a0)+
	move.l	wurzel(a5),a2
	subq.l	#1,d7
	beq.s	edhuff2
	bra.s	edhufl4
dhuffl5:move.l	2(a2),a2
	tst.l	2(a2)
	bne.s	edhufl4
	tst.l	6(a2)
	bne.s	edhufl4
	move.w	(a2),d1
	move.b	d1,(a0)+
	move.l	wurzel(a5),a2
	subq.l	#1,d7
	beq.s	edhuff2
edhufl4:subq.b	#1,d6
	bne.s	dhuffl4
	bra	dhuffl3
edhuff2:rts

* code- und datenlaenge holen
getsp:	move.b	10(a4),d2
	lsl.l	#8,d2
	move.b	11(a4),d2
	lsl.l	#8,d2
	move.b	12(a4),d2
	lsl.l	#8,d2
	move.b	13(a4),d2
	move.b	16(a4),d3
	lsl.l	#8,d3
	move.b	17(a4),d3
	lsl.l	#8,d3
	move.b	18(a4),d3
	lsl.l	#8,d3
	move.b	19(a4),d3
	rts

archive:
