	DATA	2048
* QUELLID
SID:	EQU	0

* ZIELID
DID:	EQU	4

* ANZAHL DER WIRKLICH VORHANDENEN ZEICHEN
GESZEI:	EQU	8

* GESAMTZAHL ALLER ZEICHEN
GESZAH:	EQU	10

* ZEIGER AUF WURZEL
WURZEL:	EQU	14

* POSITION IN FILE
POSI:	EQU	18

* FLAG FUER GROSS UND KLEINSCHREIBUNG
GKFLAG:	EQU	22

* KOMPRESSIONSART
COMFLAG:EQU	24

* FLAG FUER PARAMETER
PARFLAG:EQU	26

* ID FENSTER 1
CID:	EQU	28

* ID FENSTER 2
CID1:	EQU	32

* INFORMATIONEN
INFO:	EQU	36

* FLAG ZUM EXPANDIEREN
AFLAG:	EQU	46

* HEADER
FH:	EQU	48

* QUELLNAME
QNAME:	EQU	100

* ZIELNAME
ZNAME:	EQU	150

* TABELLE FUER HAEUFIGKEITEN
TAB:	EQU	200

* ZAEHLER FUER VERSCHIEDENE
VERS:	EQU     200

* ZAEHLER FUER GLEICHE
GLEICH:	EQU 	202

* PUFFER FUER DATEN
PUFFER:	EQU	204

* TABELLE FUER BAUMEINTRAEGE
TREE:	EQU	1224

* PLATZ FUER BITSTRUKTUR FUER JEDES ZEICHEN
BITMAP:	EQU	2248

* PLATZ FUER BAUMSTRUKTUR
SPACE:	EQU	4296

	BRA.S	START
	DC.L	0
	DC.W	$4AFB
	DC.W	NE-NS
NS:	DC.B	"RALF'S ARCHIVER"
NE:
	EVEN

START:	MOVEQ	#0,D7
	MOVEQ	#0,D0
	TRAP	#1		;CURRENT JOB
	TST.W	D1
	BNE.S	ANFANG
	MOVE.W	$110,A0		;INSTALL NEW PROCEDURE
	LEA	DEFS,A1
	JSR	(A0)
	RTS
DEFS:	DC.W	1
	DC.W	BASIC-*
	DC.B	6,'RB_ARC',0
	DC.W	0,0,0

* ANFANG ALS BASIROUTINE
BASIC:	MOVEQ	#0,D7
	CMP.L	A3,A5
	BEQ.S	ANFANG
	MOVE.L	A5,D0
	SUB.L	A3,D0
	LSR.L	#3,D0
	CMP.B	#2,D0
	BEQ.S	BASIC1
	CMP.B	#4,D0
	BNE.S	ANFANG
BASIC1:	MOVE.L	D0,D7
ANFANG:	MOVE.L	A6,-(A7)
	MOVEM.L	A3/A5/D7,-(A7)
	MOVEQ	#$18,D0
	MOVE.L	#16384,D1
	MOVEQ	#-1,D2
	TRAP	#1
	MOVEM.L	(A7)+,A3/A5/D7
	TST.W	D0
	BNE	EXIT
	MOVE.L	A0,-(A7)
* BASICPARAMETER HOLEN
	TST.L	D7
	BEQ.S	NBASIC
	MOVE.L	A3,A5
	ADDQ.L	#8,A5
	BSR	GETSTR
	BNE	EXBAS
* 1. NAMEN HOLEN
BASIC2:	MOVE.L	(A7),A0
	LEA	QNAME(A0),A0
	MOVE.W	D1,(A0)+
        SUBQ.W	#1,D1
B2L:	MOVE.B	(A2)+,(A0)+
	DBRA	D1,B2L
* 2. NAMEN HOLEN
	MOVE.L	A5,A3
	ADDQ.L	#8,A5
	BSR	GETSTR
	BNE.S	EXBAS
BASIC3:	MOVE.L	(A7),A0
	LEA	ZNAME(A0),A0
	MOVE.W	D1,(A0)+
        SUBQ.W	#1,D1
B3L:	MOVE.B	(A2)+,(A0)+
	DBRA	D1,B3L
	CMP.B	#2,D7
	BEQ.S	NBASIC
* COMPRESSIONART HOLEN UND GROSSFLAG
  	MOVE.L	A5,A3
	LEA	16(A5),A5
	MOVE.W	$112,A0
	JSR	(A0)
	TST.W	D0
	BNE	EXBAS
	CMP.W	#2,D3
	BNE	EXBAS
BASIC4:	MOVE.L	(A7),A0
	MOVE.W	0(A6,A1.L),COMFLAG(A0)
	MOVE.W	2(A6,A1.L),GKFLAG(A0)
NBASIC:	MOVE.L	(A7)+,A6
	MOVE.W	D7,PARFLAG(A6)
	TST.W	D7
	BEQ.S	NBASIC1
	BSR	DOIT
	MOVEQ	#$19,D0
	MOVE.L	A6,A0
	TRAP	#1
	MOVE.L	(A7)+,A6
	RTS
EXBAS:	ADDQ.L	#4,A7
	MOVE.L	(A7)+,A6
	MOVEQ	#-15,D0
	RTS
NBASIC1:CLR.W	COMFLAG(A6)
	CLR.W	GKFLAG(A6)
	LEA	CON1,A0		;FENSTER OEFFNEN
	MOVEQ	#0,D3	
	BSR	OPEN
	BNE	EXIT
	LEA	CID1(A6),A1     ;ID SICHERN
	MOVE.L	A0,(A1)
	MOVEQ	#$27,D0		;SET PAPER
	MOVEQ	#24,D1
	MOVEQ	#-1,D3
	TRAP	#3
	MOVEQ	#$29,D0		;SET INK
	MOVEQ	#7,D1
	MOVEQ	#-1,D3
	TRAP	#3
	MOVEQ	#$20,D0		;CLEAR
        MOVEQ	#-1,D3
	TRAP	#3
	MOVEQ	#$17,D0		;POSITION TEXT
	MOVEQ	#56,D1
	MOVEQ	#3,D2
	MOVEQ	#-1,D3
	TRAP	#3
	LEA	CTEXT,A1	;COPYRIGHT
	MOVE.W	$D0,A2
	JSR	(A2)
	LEA	CON2,A0		;FENSTER OEFFNEN
	MOVEQ	#0,D3	
	BSR	OPEN
	BNE	EXIT
	LEA	CID(A6),A1      ;ID SICHERN
	MOVE.L	A0,(A1)
	MOVEQ	#$27,D0		;SET PAPER
	MOVEQ	#0,D1
	MOVEQ	#-1,D3
	TRAP	#3
	MOVEQ	#$29,D0		;SET INK
	MOVEQ	#7,D1
	MOVEQ	#-1,D3
	TRAP	#3
MLOOP:	BSR	MENUE		;MENUE AUSGEBEN
	CLR.W	AFLAG(A6)
MLOOP1:	MOVEQ	#1,D0		;FETCH BYTE
	MOVEQ	#-1,D3
	TRAP	#3
	CMP.B	#232,D1		;F1
	BNE.S	MLOOP2
	BSR	DOIT
	TST.W	D0
	BEQ.S	MLOOP
	BSR	ERROR
	BRA.S	MLOOP
MLOOP2:	CMP.B	#236,D1		;F2
	BNE.S	MLOOP3
	BSR	CGK
	BRA.S	MLOOP
MLOOP3:	CMP.B	#240,D1		;F3
	BNE.S	MLOOP4
	BSR	CCOM
	BRA.S	MLOOP
MLOOP4:	CMP.B	#27,D1		;ESC
	BNE.S	MLOOP1
	MOVEQ	#$19,D0
	MOVE.L	A6,A0
	TRAP	#1
EXIT:	LEA	BYET,A1		;VERABSCHIEDUNG
	BSR	TOUT
	MOVEQ	#$F,D0
	MOVEQ	#-1,D3
	TRAP	#3
	MOVE.L	CID(A6),D0
	BEQ.S	EXIT1
	MOVE.L	D0,A0
	MOVEQ	#2,D0		;CLOSE CHANNEL
	TRAP	#2
EXIT1:  MOVE.L	CID1(A6),D0
	BEQ.S	EXIT2
	MOVE.L	D0,A0
	MOVEQ	#2,D0		;CLOSE CHANNEL
	TRAP	#2
EXIT2:	MOVE.L	(A7)+,A6
	MOVEQ	#5,D0		;REMOVE THIS JOB
	MOVEQ	#-1,D1
	TRAP	#1	
	MOVEQ	#0,D0		;FOR BASIC
	RTS

* FEHLER ANZEIGEN
ERROR:	MOVE.L	D0,-(A7)
	MOVE.L	CID(A6),A0
	MOVEQ	#$20,D0
	MOVEQ	#-1,D3
	TRAP	#3
	MOVE.L	(A7)+,D0
	MOVE.W	$CC,A1
	JSR	(A1)
	MOVEQ	#1,D0
	MOVEQ	#-1,D3
	TRAP	#3
	RTS

* GROSS/KLEIN UMSCHALTEN
CGK:	NOT.W	GKFLAG(A6)
	RTS

* KOMPRESSIONSART BESTIMMEN
CCOM:	ADD.W	#1,COMFLAG(A6)
	CMP.W	#3,COMFLAG(A6)
	BNE.S	ECCOM
	CLR.W	COMFLAG(A6)
ECCOM:	RTS

* MENUE AUSGEBEN
MENUE:	TST.W	PARFLAG(A6)
	BNE	EMENUE
	MOVE.L	CID(A6),A0
	MOVEQ	#$0E,D0		;ENABLE CURSOR
	MOVEQ	#-1,D3
	TRAP	#3
	MOVEQ	#$20,D0		;CLEAR
	MOVEQ	#-1,D3
	TRAP	#3
* ANFANG
	LEA	M1,A1		;MENUETEXT AUSGEBEN
	MOVE.W	$D0,A2
	JSR	(A2)
* GROSS/KLEIN ODER GROSS
	MOVE.W	GKFLAG(A6),D0
	BEQ.S	MENUE1
	LEA	M2B,A1
	MOVE.W	$D0,A2
	JSR	(A2)
	BRA.S	MENUE2
MENUE1:	LEA	M2A,A1
	MOVE.W	$D0,A2
	JSR	(A2)
* KOMPRESSIONSART
MENUE2:	MOVE.W	COMFLAG(A6),D0
	BNE.S	MENUE3
	LEA	M3A,A1
	MOVE.W	$D0,A2
	JSR	(A2)
	BRA.S	MENUEE
MENUE3:	CMP.W	#1,D0
	BNE.S	MENUE4
	LEA	M3B,A1
	MOVE.W	$D0,A2
	JSR	(A2)
	BRA.S	MENUEE
MENUE4:	CMP.W	#2,D0
	BNE.S	MENUEE
	LEA	M3C,A1
	MOVE.W	$D0,A2
	JSR	(A2)
MENUEE:	LEA	ME,A1
	MOVE.W	$D0,A2
	JSR	(A2)
EMENUE:	RTS

* MENUE AUSGEBEN
TOUT:	TST.W	PARFLAG(A6)
	BNE.S	ETOUT
	MOVE.L	A1,-(A7)
	MOVE.L	CID(A6),A0
	MOVEQ	#$20,D0		;CLEAR
	MOVEQ	#-1,D3
	TRAP	#3
	MOVE.L	(A7)+,A1
	MOVE.W	$D0,A2
	JSR	(A2)
ETOUT:	RTS

* DATEI(DE)KOMPRESSION
DOIT:	TST.W	PARFLAG(A6)
	BNE.S	DOIT0
	LEA	DNAME,A1
	BSR	TOUT
* QUELLENAMEN HOLEN
	MOVEQ	#2,D0
	MOVEQ	#36,D2
	MOVEQ	#-1,D3
	MOVE.L	CID(A6),A0
	LEA	QNAME+2(A6),A1
	TRAP	#3
	TST.W	D0
	BNE.S	EDOIT
	SUBQ.W	#1,D1
	MOVE.W	D1,QNAME(A6)	
DOIT0:	LEA	SID(A6),A0
	CLR.L	(A0)
	LEA	DID(A6),A0
	CLR.L	(A0)
	LEA	QNAME(A6),A0
	MOVEQ	#0,D3
	BSR	OPEN
	BNE.S	EDOIT
	LEA	SID(A6),A1
	MOVE.L	A0,(A1)
	LEA	POSI(A6),A1
	CLR.L	(A1)
* ERSTEN 4 ZEICHEN LESEN
	MOVEQ	#3,D0
	MOVEQ	#4,D2
	MOVEQ	#-1,D3
	LEA	FH(A6),A1
	TRAP	#3
	TST.W	D0
	BNE.S	EDOIT
	BSR	RESTORE
	MOVE.L	FH(A6),D0
	CMP.L	#'RBDC',D0
	BEQ.S	DOIT1
	BSR	COMPR
	BRA.S	EDOIT
DOIT1:	BSR	DCOMPR
EDOIT:	RTS

* KOMPRESSIONSART BESTIMME
COMPR:	TST.W	PARFLAG(A6)
	BEQ.S	COMPR0
	CMP.W	#4,PARFLAG(A6)
	BNE	EXBAS
	BRA	COMPRB
COMPR0:	LEA	DNAME1,A1
	BSR	TOUT
* QUELLENAMEN HOLEN
	MOVEQ	#2,D0
	MOVEQ	#36,D2
	MOVEQ	#-1,D3
	MOVE.L	CID(A6),A0
	LEA	ZNAME+2(A6),A1
	TRAP	#3
	TST.W	D0
	BNE.S	COMPR2
	SUBQ.W	#1,D1	
	MOVE.W	D1,ZNAME(A6)
COMPRB:	BSR	RESTORE
	MOVE.W	COMFLAG(A6),D0
	BNE.S	COMPR1
	BSR	NCOMPR
	RTS
COMPR1:	CMP.W	#1,D0
	BNE.S	COMPR2
	BSR	HUFFMAN
	RTS
COMPR2:	CMP.W	#2,D0
	BNE.S	COMPR3
        BSR	CBYTE
	RTS
COMPR3:	RTS

* KEINE KOMPRESSION
NCOMPR:	BSR	HEADER
	BNE.S	ENCOMPR
	MOVE.L	FH(A6),D7
NCOML:	BSR	GBCOM
	BNE.S	ENCOMPR
	BSR	PUTBYTE
	BNE.S	ENCOMPR
	SUBQ.L	#1,D7
	BNE.S	NCOML
	BSR	STPOS
ENCOMPR:BSR	CLALL
	RTS

* NACH HUFFMAN KOMPRIMIEREN
HUFFMAN:LEA	ST,A1
	BSR	TOUT
	BSR	STATI
	TST.W	D0
	BNE.S	EHUFF
	LEA	CB,A1
	BSR	TOUT
	BSR	BAUM
	LEA	CT,A1
	BSR	TOUT
* POINTER FUER JEDES ZEICHEN
	LEA	TREE(A6),A3
* POINTER FUER BITDARSTELLUNG
	LEA	BITMAP(A6),A4
* WURZEL DES BAUMS
	MOVE.L	WURZEL(A6),A5
	BSR	CLRIT
* EIN BIT ALS START
	CLR.W	(A4)
* MAXIMAL 32 BIT
	MOVEQ	#32,D7
* BITDARSTELLUNG
	MOVEQ   #0,D6
	BSR	MAKEL
	LEA	SB,A1
	BSR	TOUT
	BSR	HEADER
	BNE.S	EHUFF
	BSR	BAUMH
	BNE.S	EHUFF
	LEA	CF,A1
	BSR	TOUT
	BSR	HUFF1
	BNE.S	EHUFF
	BSR	STPOS
EHUFF:	BSR	CLALL
	RTS

* MEHRERE GLEICHE BYTES ZUSAMMENFASSEN
CBYTE:	BSR	HEADER
	BNE	ECBYTE
	MOVE.L	FH(A6),D7
CBL:	LEA	PUFFER(A6),A4
	BSR	GBCOM
	BNE	ECBYTE
	MOVE.B	D1,D6
	MOVE.B	D1,(A4)+
	MOVE.W	#1,VERS(A6)
	CLR.W	GLEICH(A6)
CBL1:   BSR	GBCOM
	BNE	ECBYTE
	ADDQ.W	#1,VERS(A6)
	ADDQ.W	#1,GLEICH(A6)
	MOVE.B	D1,(A4)+
	CMP.B	D1,D6
	BNE.S	NBG
	CMP.W	#127,VERS(A6)
	BEQ.S	NBG
* 1. GLEICHES BYTE
	BSR	GBCOM
	BNE.S	ECBYTE
	ADDQ.W	#1,VERS(A6)
	ADDQ.W	#1,GLEICH(A6)
        MOVE.B	D1,(A4)+
	CMP.B	D1,D6
	BNE.S	NBG
* 3 GLEICHE BYTES GEFUNDEN
	SUBQ.W	#3,VERS(A6)
BGL:	ADDQ.W	#1,GLEICH(A6)
	BSR	GBCOM
	BNE.S	ECBYTE
	CMP.B	D1,D6
	BNE.S	EBGL
	CMP.W	#127,GLEICH(A6)
	BEQ.S	EBGL
	SUBQ.L	#1,D7
	BNE.S	BGL
	BRA.S	ECBYTE
EBGL:   BSR	WBB
	BNE.S	ECBYTE1
	MOVE.B	D1,D6
	MOVE.B	D1,(A4)+
	MOVE.W	#1,VERS(A6)
NBG:	CLR.W	GLEICH(A6)
	CMP.W	#127,VERS(A6)
	BNE.S	NBG1
	BSR	WBB
        BNE.S	ECBYTE1
	MOVE.B	D1,D6
        SUBQ.L	#1,D7
	BNE	CBL
	BRA	ECBYTE1
NBG1:	MOVE.B	D1,D6
	SUBQ.L	#1,D7
	BNE	CBL1
ECBYTE:	MOVE.W	D0,-(A7)
	BSR	WBB
	MOVE.W	(A7)+,D0
	CMP.W	#-10,D0
	BNE.S	ECBYTE1
	MOVEQ	#0,D0
ECBYTE1:BSR	STPOS
	BSR	CLALL
	RTS

* BLOCK VON KOMPRIMIERTEN BYTES SCHREIBEN
* VERSCHIEDENEN SCHREIBEN
WBB:	MOVE.W	D1,-(A7)
* VERSCHIEDENE BYTES SCHREIBEN
	LEA	PUFFER(A6),A4
	MOVE.W	VERS(A6),D6
	SUBQ.W	#1,D6
	BMI.S	WBBG
	MOVE.B	D6,D1
	BSR	PUTBYTE
	BNE.S	WBBE
WBBV:	MOVE.B	(A4)+,D1
	BSR	PUTBYTE
	BNE.S	WBBE
	DBRA	D6,WBBV
WBBG:	MOVE.W	#1,VERS(A6)
	MOVE.W	GLEICH(A6),D6
	SUBQ.W	#1,D6
	BMI.S   WBBE
	MOVE.B	D6,D1
	BSET	#7,D1
	BSR	PUTBYTE
	BNE.S	WBBE
	MOVE.B	(A4),D1
	BSR	PUTBYTE
WBBE:	LEA	PUFFER(A6),A4
	MOVE.W	(A7)+,D1
	TST.W	D0
	RTS

* EXPANDIEREN
DCOMPR:	TST.W	PARFLAG(A6)
	BEQ.S	DCOMPR0
	MOVE.W	#1,AFLAG(A6)
	LEA	ZNAME(A6),A0
	LEA	QNAME(A6),A1
	MOVE.W	(A0),D0	
	ADDQ.W	#1,D0
DCBASL:	MOVE.B	(A0)+,(A1)+
	DBRA	D0,DCBASL
	CMP.W	#2,PARFLAG(A6)
	BNE	EXBAS
	BRA.S	DCOML
DCOMPR0:LEA	DEVICE,A1
	BSR	TOUT
* DEVICENAMEN HOLEN
	MOVEQ	#2,D0
	MOVEQ	#36,D2
	MOVEQ	#-1,D3
	MOVE.L	CID(A6),A0
	LEA	QNAME+2(A6),A1
	TRAP	#3
	TST.W	D0
	BNE	EDCOM
	SUBQ.W	#1,D1
	MOVE.W	D1,QNAME(A6)	
* SCHLEIFE UM ALLE ZU DECOMPRIMIEREN
* INFORMATIONEN LESEN, LAENGE+KOMPRESSIONSART
DCOML:	MOVE.L	SID(A6),A0
	MOVEQ	#3,D0
	MOVEQ	#10,D2
	MOVEQ	#-1,D3
	LEA	INFO(A6),A1
	TRAP	#3
	CMP.W	#-10,D0
	BEQ	EDCOM1
	TST.W	D0
	BNE	EDCOM
* FILEHEADER LESEN
	MOVEQ	#3,D0
	MOVEQ	#52,D2
	MOVEQ	#-1,D3
	LEA	FH(A6),A1
	TRAP	#3
	TST.W	D0
	BNE	EDCOM
	TST.W	AFLAG(A6)
	BNE.S	DCOM0
* FRAGEN OB ENTPACKT WERDEN SOLL
	LEA	FH+14(A6),A1
	BSR	TOUT
	LEA	EPACK,A1
	MOVE.W	$D0,A2
	JSR	(A2)
DCOMF:	MOVEQ	#1,D0
	MOVEQ	#-1,D3
	TRAP	#3
	BCLR	#5,D1
	CMP.B	#'N',D1
	BEQ.S	EDCOML
	CMP.B	#'J',D1
	BEQ.S	DCOM0
	CMP.B	#'Q',D1
	BEQ.S	EDCOM1
	CMP.B	#'A',D1
	BNE.S	DCOMF
	NOT.W	AFLAG(A6)
DCOM0:	LEA	FH+14(A6),A1
	BSR	TOUT
	TST.W	PARFLAG(A6)
	BNE.S	DCOMB
	LEA	EPACKOK,A1
	MOVE.W	$D0,A2
	JSR	(A2)
DCOMB:	MOVE.W	INFO+8(A6),D0
	BNE.S	DCOM1
	BSR	DNCOM
	BRA.S	EDCOML
DCOM1:	CMP.W	#1,D0
	BNE.S	DCOM2
	BSR	DHUFF
	BRA.S	EDCOML
DCOM2:	CMP.W	#2,D0
	BNE.S	EDCOML
	BSR	DCBYTE
EDCOML:	MOVE.L	SID(A6),A0
	MOVEQ	#$42,D0
	MOVE.L	INFO+4(A6),D1
	MOVEQ	#-1,D3
	TRAP	#3
	BRA	DCOML
EDCOM:	BSR	CLALL
	RTS
EDCOM1:	MOVEQ	#0,D0
	BRA.S	EDCOM

* BYTEWEISE DEKOMPRIMIEREN
DCBYTE:	BSR	MNAME
	BNE.S	EDCBL
DCBL:	BSR	GBEXP
	BNE.S	EDCBL
	BTST	#7,D1
	BEQ.S	DCBL2
	AND.W	#$007F,D1
	MOVE.W	D1,D7
	BSR	GBEXP
	BNE.S	EDCBL
	MOVE.B	D1,D6
DCBL1:	MOVE.B	D6,D1
	BSR	PUTBYTE
	BNE.S	EDCBL
	DBRA	D7,DCBL1
	BRA.S	DCBL
DCBL2:	AND.W	#$007F,D1
	MOVE.W	D1,D7
DCBL3:	BSR	GBEXP
	BNE.S	EDCBL
	BSR	PUTBYTE
	BNE.S	EDCBL
	DBRA	D7,DCBL3
	BRA.S	DCBL
EDCBL:	BSR	FCL
        RTS

* WORTWEISE DEKOMPRIMIEREN

* NACH HUFFMAN DEKOMPRIMIEREN
DHUFF:	TST.W	PARFLAG(A6)
	BNE.S	DHUFFB0
	LEA	FH+14(A6),A1
	BSR	TOUT
	LEA	CB,A1
	MOVE.W	$D0,A2
	JSR	(A2)
DHUFFB0:BSR	MBAUM
	BNE.S	EDHUFF
	BSR	MNAME
	BNE.S	EDHUFF
	TST.W	PARFLAG(A6)
	BNE.S	DHUFFB1
	LEA	FH+14(A6),A1
	BSR	TOUT
	LEA	CF,A1
	MOVE.W	$D0,A2
	JSR	(A2)
DHUFFB1:BSR	DHUFF1
EDHUFF:	RTS

* OHNE KOMRESSION HERAUSHOLEN
DNCOM:	BSR	MNAME
	BNE.S	EDNCOM
	MOVE.L	FH(A6),D7
DNCOML:	BSR	GBEXP
	BNE.S	EDNCOM
	BSR	PUTBYTE
	BNE.S	DNCOML
	SUBQ.L	#1,D7
	BNE.S	DNCOML
EDNCOM:	BSR	FCL
	RTS

* ALLE DATEIEN SCHLIESSEN
CLALL:	MOVE.L  D0,-(SP)
	MOVE.L	SID(A6),D0
	BEQ.S	CLALL1
	MOVE.L	D0,A0
	MOVEQ	#2,D0
	TRAP	#2
CLALL1:	MOVE.L	DID(A6),D0
	BEQ.S	ECLALL
	MOVE.L	D0,A0
	MOVEQ	#2,D0
	TRAP	#2
ECLALL:	MOVE.L	(SP)+,D0
	RTS
	
* DATEI OEFFNEN
OPEN:	MOVEQ	#1,D0
	MOVEQ	#-1,D1
	TRAP	#2
	TST.W	D0
	RTS

* DATEI SCHLIESSEN
CLOSE	MOVEQ	#2,D0
	TRAP	#2
	RTS

* ZWEI KLEINSTEN EINTRAEGE SUCHEN
MINI:	MOVE.W	#255,D6
* RELATIVER POINTER ZUM ERSTEN WERT
	MOVEQ	#0,D5
* GROESSTE INTEGER
	MOVE.L	#$7FFFFFFF,D0
* D0=MIN1 D1=MIN2 D2=CHAR1 D3=CHAR2
	MOVE.L	D0,D1
* BAUM BELEGT ?
MINIL:	TST.L	0(A3,D5.W)
	BEQ.S	EMINIL
* ANZAHL HOLEN
	MOVE.L	0(A2,D5.W),D4
* KLEINER ALS KLEINSTER ?
	CMP.L	D4,D1
	BLT.S	MINIL1
	MOVE.L	D1,D0
	MOVE.L	D4,D1
	MOVE.W	D3,D2
	MOVE.W	D5,D3
	BRA.S	EMINIL
* KLEINER ALS ZWEITKLEINSTER
MINIL1: CMP.L	D4,D0
	BLT.S	EMINIL
	MOVE.L	D4,D0
	MOVE.W	D5,D2
EMINIL:	ADDQ.W	#4,D5
	DBRA	D6,MINIL
	RTS	

* BAUM AUFBAUEN
* ERSTE SCHRITT BAUM VORBEREITEN
BAUM:	LEA	SPACE(A6),A4
	LEA	TREE(A6),A3
	LEA	TAB(A6),A2
* NOCH SIND ES 256 ZEICHEN
	MOVE.W	#255,D7
* SCHLEIFE UEBER 256 ZEICHEN
	MOVE.W	#255,D6
BAUML:	MOVE.W	D6,D0
* EINTRAG FINDEN
	LSL.W	#2,D0
* EINTRAG FREI ?
	TST.L	0(A2,D0.W)
* NEIN
	BNE.S	BAUML1
* KEIN AST
	CLR.L	0(A3,D0.W)
* EIN ZEICHEN WENIGER
	SUBQ.W	#1,D7
	BRA.S	EBAUML
* ZEIGER AUF AST
BAUML1:	MOVE.L	A4,0(A3,D0.W)
* AST VORBEREITEN
* ERSTER EINTRAG ZEICHEN VOM AST
	MOVE.W	D6,(A4)+
* ZWEITER EINTRAG POINTER AUF LINKEN NACHBARN
	CLR.L	(A4)+
* DRITTER EINTRAG POINTER AUF RECHTEN NACHBARN
	CLR.L	(A4)+
EBAUML:	DBRA	D6,BAUML
	LEA	GESZEI(A6),A0
	MOVE.W	D7,(A0)
* EIGENTLICHEN BAUM AUFBAUEN
BAUML2:	TST.W	D7
	BEQ.S	EBAUM
* ZWEI KLEINSTEN EINTRAGE FINDEN
	BSR	MINI
* BAUM MIN1
	LEA	0(A3,D3.W),A0
* BAUM MIN2
	LEA	0(A3,D2.W),A1
	MOVE.L	0(A2,D2.W),D0
	ADD.L	D0,0(A2,D3.W)
	LSR.W	#2,D3
	MOVE.L	A4,A5
	MOVE.W	D3,(A4)+
	MOVE.L	(A0),(A4)+
	MOVE.L	(A1),(A4)+
	MOVE.L	A5,(A0)
	CLR.L	(A1)
  	SUBQ.W	#1,D7
	BRA.S	BAUML2
EBAUM:	MOVE.W	#255,D7
BAUML3:	MOVE.L	(A3)+,D0
	BNE.S	EBAUML3
	DBRA	D7,BAUML3
EBAUML3:LEA	WURZEL(A6),A0
	MOVE.L	D0,(A0)
	LEA	GESZAH(A6),A0
	MOVE.L	D0,A1
	MOVE.W	(A1),D0
	LSL.W	#2,D0
	MOVE.L	0(A2,D0.W),(A0)
	RTS

* DATEI TESTEN UND STATISKTIK AUFBAUEN
STATI:	LEA	TAB(A6),A2
* TABELLE LOESCHEN
	MOVE.W	#255,D7
STAL:	CLR.L	(A2)+
	DBRA	D7,STAL
* NEUE TABELLE BILDEN
	LEA	TAB(A6),A2
* ZEICHEN HOLEN
STATM:	BSR	GBCOM
	CMP.W	#-10,D0
	BEQ.S	STATOK
	TST.W	D0
	BNE.S	ESTAT
	AND.W	#255,D1
	LSL.W	#2,D1
	ADDQ.L	#1,0(A2,D1.W)
        BRA.S	STATM
STATOK:	MOVEQ	#0,D0
ESTAT:	RTS

* TABELLEN LOESCHEN
CLRIT:	MOVE.L	A3,-(A7)
	MOVE.W	#255,D7
CLRL:	CLR.L	(A3)+
	DBRA	D7,CLRL
	MOVE.L	(A7)+,A3
	RTS

* BITMAP FUER JEDES ZEICHEN ERSTELLEN
* RECHTER NACHBAR
MAKEL:	TST.L	6(A5)
	BNE.S	MAKEL1
* LINKER NACHBAR	
	TST.L	2(A5)
	BNE.S	MAKEL1
* BITDARSTELLUNG FUER EIN ZEICHEN GEFUNDEN
	MOVE.W	(A5),D0
	LSL.W	#2,D0
	MOVE.L	A4,0(A3,D0.W)
	MOVE.L	D6,2(A4)
	MOVE.W	(A4),6(A4)
	LEA	6(A4),A4
	RTS
* REKURSIV DAS ENDE SUCHEN
* ZUERST ALLE RECHTEN NACHBARN
* BIT=1 BEDEUTET RECHTS
MAKEL1:	SUBQ.L	#1,D7
	BSET	D7,D6
	ADDQ.W	#1,(A4)
	MOVE.L	A5,-(A7)
	MOVE.L	6(A5),A5
	BSR.S	MAKEL
	MOVE.L	(A7)+,A5
	CLR.L	6(A5)
	BCLR	D7,D6
* JETZT DIE LINKEN NACHBARN
* BIT=0 BEDEUTET LINKS
	MOVE.L	A5,-(A7)
        MOVE.L	2(A5),A5
	BSR.S	MAKEL
	MOVE.L	(A7)+,A5
	CLR.L	2(A5)
	SUBQ.W	#1,(A4)
	ADDQ.L	#1,D7
	RTS

* AKTUELLE POSITION MERKEN
STPOS:  MOVE.L	DID(A6),A0
	MOVEQ	#$42,D0
	MOVE.L	#$7FFFFFFF,D1
	MOVEQ	#-1,D3
	TRAP	#3
	CMP.W	#-10,D0
	BNE.S	ESTPOS
	MOVE.L	D1,FH(A6)
	MOVEQ	#$42,D0
	MOVE.L	POSI(A6),D1
	MOVEQ	#-1,D3
	TRAP	#3
	TST.W	D0
	BNE.S	ESTPOS
	MOVEQ	#7,D0
	MOVEQ	#4,D2
	MOVEQ	#-1,D3
	LEA	FH(A6),A1
	TRAP	#3
ESTPOS:	RTS

* HEADER MIT ALLEN INFORMATIONEN ERSTELLEN
* HEADER VON QUELLE LESEN
HEADER:	MOVEM.L	A3-A5,-(A7)
	LEA	ZNAME(A6),A0
	MOVEQ	#2,D3
	BSR	OPEN
	BEQ.S	HEADER1
	LEA	ZNAME(A6),A0
	MOVEQ	#0,D3
	BSR	OPEN
	BNE	EHEAD
	MOVEQ	#3,D0
	MOVEQ	#10,D2
	MOVEQ	#-1,D3
	LEA	INFO(A6),A1
	TRAP	#3
	TST.W	D0
	BNE	EHEAD
	CMP.L	#'RBDC',INFO(A6)
	BNE	EHEAD
HEADER1:LEA	DID(A6),A1
	MOVE.L	A0,(A1)
* POINTER ANS ENDE
HEADER2:MOVEQ	#$42,D0
	MOVE.L	#$7FFFFFFF,D1
	MOVEQ	#-1,D3
	TRAP	#3
	CMP.W	#-10,D0
	BNE	EHEAD
	ADDQ.L	#4,D1
	MOVE.L	D1,POSI(A6)
	MOVEQ	#$47,D0
	MOVEQ	#52,D2
	MOVEQ	#-1,D3
	MOVE.L	SID(A6),A0
	LEA	FH(A6),A1
	TRAP	#3
	TST.W	D0
	BNE	EHEAD
	TST.B	FH+4(A6)
	BEQ.S	NJOB
	CLR.W	GKFLAG(A6)
* KOMPRESSION EINTRAGEN
NJOB:   MOVEQ	#7,D0
	MOVEQ	#8,D2
	MOVEQ	#-1,D3
	MOVE.L	DID(A6),A0
	LEA	RBCOM,A1
	TRAP	#3
	TST.W	D0
	BNE	EHEAD
* KOMPRESSIONSART FESTLEGEN
	MOVEQ	#7,D0
	MOVEQ	#2,D2
	MOVEQ	#-1,D3
	LEA	COMFLAG(A6),A1
	TRAP	#3
	TST.W	D0
	BNE	EHEAD
* HEADER SCHREIBEN
	MOVEQ	#7,D0
	MOVEQ	#52,D2
	MOVEQ	#-1,D3
	LEA	FH(A6),A1
	TRAP	#3
EHEAD:	MOVEM.L	(A7)+,A3-A5
	TST.W	D0
	RTS

* BAUM ABSPEICHERN A3=BAUM
BAUMH:	MOVEM.L	A3-A5,-(A7)
	MOVE.W	#255,D7
* 4*2 BITS
        MOVEQ	#8,D6
* KEIN BIT GESETZT
	MOVEQ	#0,D5
HEADL:	MOVE.L	(A3)+,D0
	BEQ.S	EHEADL
	MOVE.L	D0,A2
* ANZAHL DER BITS
	MOVE.W	(A2)+,D4
* BITMUSTER
	MOVE.L	(A2),D3
HEADL1:	LSL.B	#2,D5
	LSL.L	#1,D3
	BCC.S	HEADL2
	OR.B	#1,D5
HEADL2:	SUBQ.B	#2,D6
	BNE.S	HEADL3
	MOVE.W	D5,D1
	BSR	PUTBYTE
	BNE	EHEAD
	MOVEQ	#8,D6
HEADL3: SUBQ.W	#1,D4
	BNE.S	HEADL1
EHEADL:	LSL.B	#2,D5
	OR.B	#3,D5
	SUBQ.B	#2,D6
	BNE	EHEADL1
	MOVE.W	D5,D1
	BSR	PUTBYTE
	BNE.S	EHEAD
	MOVEQ	#8,D6
EHEADL1:DBRA	D7,HEADL
* LETZTES BYTE EINTRAGEN
	CMP.B	#8,D6
	BEQ.S	EHEAD
	LSL.B	D6,D5
	MOVE.W	D5,D1
	BSR	PUTBYTE	
EBAUMH:	MOVEM.L	(A7)+,A3-A5
	TST.W	D0
	RTS

* BAUM ZUM EXPANDIEREN ERZEUGEN
* PLATZ FUER ZEICHEN
MBAUM:	
* PLATZ FUER BAUM
	LEA	BITMAP+10(A6),A4
	LEA	BITMAP(A6),A5
* BAUM LOESCHEN
	MOVE.W	#2047,D7
MBL:	CLR.L	(A5)+
	DBRA	D7,MBL
	LEA	BITMAP(A6),A5
	MOVE.L	A5,WURZEL(A6)
* 256 ZEICHEN
	MOVE.W	#255,D7
* 1. ZEICHEN
	MOVEQ	#0,D6
* BYTE HOLEN
MBL1:	BSR	GBEXP
	BNE	EMBAUM
* 4 BITS PRO BYTE
	MOVEQ	#4,D5
MBL2:	ROL.B	#2,D1
	MOVE.B	D1,D2
	AND.B	#3,D2
* LINKER AST
	BEQ.S	MBLINKS
* ENDE FUER ZEICHEN
	CMP.B	#3,D2
	BEQ	EMBL1
* RECHTER AST
	MOVE.L	6(A5),D0
	BEQ.S	MBL4
	MOVE.L	D0,A5
	BRA.S	EMBL3
* NEUER RECHTER AST
MBL4:	MOVE.L	A4,6(A5)
	LEA	10(A4),A4
	MOVE.L	6(A5),A5
	BRA.S	EMBL3
* LINKER AST
MBLINKS:MOVE.L	2(A5),D0
	BEQ.S	MBL5
	MOVE.L	D0,A5
	BRA.S	EMBL3
* NEUER LINKER AST
MBL5:	MOVE.L	A4,2(A5)
	LEA	10(A4),A4
	MOVE.L	2(A5),A5
	BRA.S	EMBL3
EMBL1:	CMP.L	WURZEL(A6),A5
	BEQ.S	EMBL2
* NEUES ZEICHEN
	MOVE.W	D6,(A5)
	MOVE.L	WURZEL(A6),A5
	SUBQ.W	#1,D5
	BEQ.S	MBL3
	ADDQ.W	#1,D6
	MOVEQ	#0,D0
	DBRA	D7,MBL2
	BRA.S	EMBAUM
MBL3:	ADDQ.W	#1,D6
	MOVEQ	#0,D0
	DBRA	D7,MBL1
	BRA.S	EMBAUM
EMBL2:	ADDQ.W	#1,D6
	SUBQ.W	#1,D5
	BEQ.S	MBL6
        DBRA	D7,MBL2
	MOVEQ	#0,D0
	BRA.S	EMBAUM
EMBL3:	SUBQ.W	#1,D5
	BNE.S	MBL2
	BRA	MBL1
MBL6:	DBRA	D7,MBL1
	MOVEQ	#0,D0
EMBAUM:	TST.W	D0
	RTS

* DATEI COMPRIMIEREN
HUFF1:	BSR	RESTORE
	BNE	EHUFF1
* 8 BIT PRO BYTE
	MOVEQ	#8,D7
* 1. BYTE LEER
	MOVEQ	#0,D6
HUFFL:	BSR	GBCOM
	BNE	EHUFF1
* BITDARSTELLUNG HOLEN
	AND.W	#255,D1
	LSL.W	#2,D1
	MOVE.L	0(A3,D1.W),A4
* ANZAHL DER BITS HOLEN
HUFFL1:	MOVE.W	(A4),D5		
	MOVE.L	2(A4),D4
* BITS EINZELN UEBERTRAGEN
HUFFL2:	TST.W	D7
	BNE.S	HUFFL3
	MOVE.W	D6,D1
	BSR	PUTBYTE
	MOVEQ	#8,D7
	MOVEQ	#0,D6
HUFFL3:	SUBQ.W	#1,D7
	ROXL.L	#1,D4
	ROXL.B	#1,D6
	SUBQ.W	#1,D5
	BNE.S	HUFFL2
	BRA.S	HUFFL
* LETZTES BYTE AUCH NOCH EINTRAGEN
EHUFF1:	CMP.W	#8,D7
	BEQ.S	EXHUFF
HUFFL4:	TST.W	D7
	BEQ.S	HUFFL5
	LSL.B	#1,D6
	SUBQ.W	#1,D7
	BRA.S	HUFFL4
HUFFL5:	MOVE.W	D6,D1
	BSR	PUTBYTE
EXHUFF:	RTS

* DATEI EXPANDIEREN
* DATEI OEFFNEN
MNAME:	LEA	DID(A6),A0
	CLR.L	(A0)
	LEA	QNAME(A6),A0
	LEA	ZNAME(A6),A1
	MOVE.W	(A0),D1
	ADDQ.W	#1,D1
MNAMEL1:MOVE.B	(A0)+,(A1)+
	DBRA	D1,MNAMEL1
	LEA	FH+14(A6),A0
	MOVE.W	(A0)+,D1
	ADD.W	D1,ZNAME(A6)
	SUBQ.W	#1,D1
	BMI.S	EMNL1
MNAMEL2:MOVE.B	(A0)+,(A1)+
	DBRA	D1,MNAMEL2
EMNL1:	LEA	ZNAME(A6),A0
	MOVEQ	#2,D3
	BSR	OPEN
	BNE	EMNL2
	LEA	DID(A6),A1
	MOVE.L	A0,(A1)
EMNL2:	TST.W	D0
	RTS

* DEKOMPRIMIEREN NACH HUFFMAN
* ANZAHL DER ZU SCHREIBENDEN BYTES FESTSTELLEN
DHUFF1:	MOVEQ	#0,D0
	MOVE.L	FH(A6),D7
	BEQ	EDHUFF2
	MOVE.L	WURZEL(A6),A5
DHUFFL3:BSR	GBEXP
	BNE	EDHUFF2
* 8 BITS
	MOVE.B	D1,D5
	MOVEQ	#0,D0
	MOVEQ	#8,D6
DHUFFL4:LSL.B	#1,D5
	BCC.S	DHUFFL5
	MOVE.L	6(A5),A5
	TST.L	2(A5)
	BNE.S	EDHUFL4
	TST.L	6(A5)
	BNE.S	EDHUFL4
	MOVE.W	(A5),D1
	BSR	PUTBYTE
	MOVE.L	WURZEL(A6),A5
	SUBQ.L	#1,D7
	BEQ.S	EDHUFF2
	BRA.S	EDHUFL4
DHUFFL5:MOVE.L	2(A5),A5
	TST.L	2(A5)
	BNE.S	EDHUFL4
	TST.L	6(A5)
	BNE.S	EDHUFL4
	MOVE.W	(A5),D1
	BSR	PUTBYTE
	MOVE.L	WURZEL(A6),A5
	SUBQ.L	#1,D7
	BEQ.S	EDHUFF2
EDHUFL4:SUBQ.B	#1,D6
	BNE.S	DHUFFL4
	BRA	DHUFFL3
EDHUFF2:BSR	FCL
	RTS

* DATEI SCHLIESSEN UND HEADER SCHREIBEN
FCL:	MOVE.L	D0,-(A7)
	MOVE.L	DID(A6),D0
	BEQ.S	EFCL
	MOVE.L	D0,A0
	MOVEQ	#$46,D0
	MOVEQ	#-1,D3
	LEA	FH(A6),A1
	TRAP	#3
	MOVEQ	#2,D0
	TRAP	#2
EFCL:	MOVE.L	(A7)+,D0
	RTS

* QUELLDATEI AUF POINTER 0
RESTORE:MOVEQ	#$42,D0
	MOVEQ	#0,D1
	MOVEQ	#-1,D3
	MOVE.L	SID(A6),A0
	TRAP	#3
	TST.W	D0
	RTS

* BYTE AUS QUELLE HOLEN ZUM KOMRIMIEREN
GBCOM:	MOVEM.L	D2-D3/A0,-(A7)
	MOVEQ	#1,D0
	MOVEQ	#-1,D3
	MOVE.L	SID(A6),A0
	TRAP	#3
	MOVE.W	GKFLAG(A6),D2
	BEQ.S	EGBCOM
	CMP.B	#'A',D1
	BLT.S	EGBCOM
	CMP.B	#'Z',D1
	BHI.S	EGBCOM
	BCLR	#5,D1
EGBCOM:	MOVEM.L	(A7)+,D2-D3/A0
	TST.W	D0
	RTS

* BYTE AUS QUELLE HOLEN ZUM EXPANDIEREN
GBEXP:	MOVEM.L	D2-D3/A0,-(A7)
	MOVEQ	#1,D0
	MOVEQ	#-1,D3
	MOVE.L	SID(A6),A0
	TRAP	#3
	MOVEM.L	(A7)+,D2-D3/A0
	TST.W	D0
	RTS

* BYTE IN ZIEL SCHREIBEN
PUTBYTE:MOVEM.L	D2-D3/A0,-(A7)
	MOVEQ	#5,D0
	MOVEQ	#-1,D3
	MOVE.L	DID(A6),A0
	TRAP	#3
	MOVEM.L	(A7)+,D2-D3/A0
	TST.W	D0
	RTS


*UNTERPROGRAMM UM STRING ZU ERHALTEN
GETSTR  CMP.L   A3,A5
        BEQ     GETSTRE
        MOVE.W  0(A6,A3.L),D0
	AND.W	#7,D0
        CMP.W   #$0002,D0
        BNE.S   GETSTR1
        MOVEQ   #0,D0
        MOVEQ   #0,D1
        MOVE.W  2(A6,A3.L),D0
        LSL.L   #3,D0
        ADD.L   $18(A6),D0
        MOVE.W  2(A6,D0.L),D1
        ADD.L   $20(A6),D1
        LEA     0(A6,D1.L),A2
        MOVE.B  (A2)+,D1
        AND.W   #$00FF,D1
        MOVEQ   #0,D0
        TST.W   D0
        RTS
GETSTR1 MOVE.W  $116,A2
        JSR     (A2)
        TST.W   D0
        BNE     GETSTRE
        LEA     0(A6,A1.L),A2
        MOVE.W  (A2)+,D1
        MOVEQ   #0,D0
        TST.W   D0
GETSTR2 RTS

GETSTRE MOVEQ   #-1,D0
        TST.W   D0
        RTS

* HEADER ZUR KOMPRESSIONSKENNUNG
RBCOM	DC.B	'RBDC    '

CON1:	DC.W	CON1E-CON1S
CON1S:	DC.B	'CON_384X30A64X0_16'
CON1E:
	EVEN

CON2:	DC.W	CON2E-CON2S
CON2S:	DC.B	'CON_376X10A68X16_16'
CON2E:
	EVEN

ST:	DC.W	STE-STS
STS:	DC.B	' ERSTELLE STATISTIK'
STE:
	EVEN

CB:	DC.W	CBE-CBS
CBS:	DC.B	' GENERIERE BAUM'
CBE:
	EVEN

CT:	DC.W	CT1E-CT1S
CT1S:	DC.B	' ERSTELLE TABELLE'
CT1E:
	EVEN

SB:	DC.W	SBE-SBS
SBS:	DC.B	' SCHREIBE BAUM'
SBE:
	EVEN

CF:	DC.W	CFE-CFS
CFS:	DC.B	' SCHREIBE DATEI'
CFE:
	EVEN
CTEXT:	DC.W	CTE-CTS
CTS:	DC.B	'ARCHIVER VON RALF BIEDERMANN 02.08.89'
CTE:
	EVEN

M1:	DC.W	M1E-M1S
M1S:	DC.B	'F1=ANFANG '
M1E:
	EVEN

M2A:	DC.W	M2AE-M2AS
M2AS:	DC.B	'F2=GRO/KLEIN '
M2AE:
	EVEN

M2B:	DC.W	M2BE-M2BS
M2BS:	DC.B	'F2=GRO '
M2BE:
	EVEN

M3A:	DC.W	M3AE-M3AS
M3AS:	DC.B	'F3=UNKOMPRIMIERT '
M3AE:	
	EVEN

M3B:	DC.W	M3BE-M3BS
M3BS:	DC.B	'F3=HUFFMAN '
M3BE:
	EVEN

M3C:	DC.W	M3CE-M3CS
M3CS:	DC.B	'F3=BYTE '
M3CE:
	EVEN

ME:	DC.W	MEE-MES
MES:	DC.B	'<ESC>=ENDE'
MEE:
	EVEN

BYET:	DC.W	BTE-BTS
BTS:	DC.B	'VIELE GRUESSE VON RBSOFT 89'
BTE:
	EVEN

EPACK:	DC.W	EPE-EPS
EPS:	DC.B	' ENTPACKEN ? J/N/A/Q'
EPE:
	EVEN

EPACKOK:DC.W	EPOKE-EPOKS
EPOKS:	DC.B	' WIRD ENTPACKT'
EPOKE:
	EVEN

DNAME:	DC.W	DNE-DNS
DNS:	DC.B	'QUELLDATEI:'
DNE:
	EVEN	

DNAME1:	DC.W	DNE1-DNS1
DNS1:	DC.B	'ZIELDATEI:'
DNE1:
	EVEN	

DEVICE:	DC.W	DEVE-DEVS
DEVS:	DC.B	'ZIELDEVICE:'
DEVE:
	EVEN
